/*
 * Decompiled with CFR 0.152.
 */
package fire.pb.callback;

import fire.pb.callback.BitConverter;
import java.io.UnsupportedEncodingException;
import java.nio.ByteBuffer;

public class Message {
    private byte[] body;
    private short iMessageNum = 0;
    private short iMessageLen = 0;
    private int iPosition = 4;

    public Message(short iMessageNum) {
        this.iMessageNum = iMessageNum;
        this.body = new byte[1024];
    }

    public Message(ByteBuffer buff) {
        this.body = buff.array();
    }

    public void readHeader() throws ArrayIndexOutOfBoundsException {
        if (this.body.length < 2) {
            throw new ArrayIndexOutOfBoundsException();
        }
        this.iMessageNum = BitConverter.hostBytesToShort(this.body);
        if (this.body.length < 4) {
            throw new ArrayIndexOutOfBoundsException();
        }
        this.iMessageLen = BitConverter.hostBytesToShort(this.body, 2);
    }

    public short readShort() throws ArrayIndexOutOfBoundsException {
        if (this.body.length >= this.iPosition + 2) {
            short iValue = BitConverter.hostBytesToShort(this.body, this.iPosition);
            this.iPosition += 2;
            return iValue;
        }
        throw new ArrayIndexOutOfBoundsException();
    }

    public int readInt() throws ArrayIndexOutOfBoundsException {
        if (this.body.length >= this.iPosition + 4) {
            int iValue = BitConverter.hostBytesToInt(this.body, this.iPosition);
            this.iPosition += 4;
            return iValue;
        }
        throw new ArrayIndexOutOfBoundsException();
    }

    public void writeShort(short iValue) throws ArrayIndexOutOfBoundsException {
        if (this.body.length >= this.iPosition + 2) {
            byte[] temp = BitConverter.shortToHostBytes(iValue);
            System.arraycopy(temp, 0, this.body, this.iPosition, 2);
            this.iPosition += 2;
        } else {
            throw new ArrayIndexOutOfBoundsException();
        }
    }

    public void writeInt(int iValue) throws ArrayIndexOutOfBoundsException {
        if (this.body.length >= this.iPosition + 4) {
            byte[] temp = BitConverter.intToHostBytes(iValue);
            System.arraycopy(temp, 0, this.body, this.iPosition, 4);
            this.iPosition += 4;
        } else {
            throw new ArrayIndexOutOfBoundsException();
        }
    }

    public String readString() throws ArrayIndexOutOfBoundsException {
        if (this.body.length >= this.iPosition + 2) {
            short iLength = BitConverter.hostBytesToShort(this.body, this.iPosition);
            if (this.body.length >= this.iPosition + 2 + iLength) {
                byte[] temp = new byte[iLength];
                System.arraycopy(this.body, this.iPosition + 2, temp, 0, iLength);
                String strValue = "";
                try {
                    strValue = new String(temp, "UTF-8");
                }
                catch (UnsupportedEncodingException unsupportedEncodingException) {
                    // empty catch block
                }
                this.iPosition += 2 + iLength;
                return strValue;
            }
            throw new ArrayIndexOutOfBoundsException();
        }
        throw new ArrayIndexOutOfBoundsException();
    }

    public void writeString(String strValue) throws ArrayIndexOutOfBoundsException {
        block3: {
            try {
                byte[] buf = strValue.getBytes("UTF-8");
                short iLength = (short)buf.length;
                if (this.body.length >= this.iPosition + 2 + iLength) {
                    byte[] temp = BitConverter.shortToHostBytes(iLength);
                    System.arraycopy(temp, 0, this.body, this.iPosition, 2);
                    System.arraycopy(buf, 0, this.body, this.iPosition + 2, iLength);
                    this.iPosition += 2 + iLength;
                    break block3;
                }
                throw new ArrayIndexOutOfBoundsException();
            }
            catch (UnsupportedEncodingException unsupportedEncodingException) {
                // empty catch block
            }
        }
    }

    public ByteBuffer toSend() {
        byte[] temp = BitConverter.shortToHostBytes(this.iMessageNum);
        System.arraycopy(temp, 0, this.body, 0, 2);
        this.iMessageLen = (short)(this.iPosition - 4);
        temp = BitConverter.shortToHostBytes(this.iMessageLen);
        System.arraycopy(temp, 0, this.body, 2, 2);
        temp = new byte[4 + this.iMessageLen];
        System.arraycopy(this.body, 0, temp, 0, 4 + this.iMessageLen);
        return ByteBuffer.wrap(temp);
    }

    public short getMessageNum() {
        return this.iMessageNum;
    }

    public void setMessageNum(short iMessageNum) {
        this.iMessageNum = iMessageNum;
    }

    public short getMessageLen() {
        return this.iMessageLen;
    }

    public void setMessageLen(short iMessageLen) {
        this.iMessageLen = iMessageLen;
    }
}

